//------------------------------------------------------------------------------
//   Implementierung einer Stack-Datenstruktur
//   zuletzt geaendert:        20.09.2001/Kp
//------------------------------------------------------------------------------
#include <stdlib.h>

// Strukturen
typedef struct tagITEM
{  int               key;            // Schlsselfeld
   struct tagITEM    *next;          // Informationsfeld
}  ITEM;

ITEM   *anker, *tail, *item;

// Prototypen
void StackInit  (void);              // Leeren Stack erzeugen
int  StackEmpty (void);              // Abfragen, ob Stack leer ist
void push       (int value);         // Item in den Stack bringen
int  pop        (void);              // Item vom Stack holen


//------------------------------------------------------------------------------
//                   StackInit:  Leeren Stack erzeugen
//------------------------------------------------------------------------------
void StackInit(void)
{
   anker = (ITEM *)malloc(sizeof *anker);
   tail  = (ITEM *)malloc(sizeof *tail);
   anker->next   = tail;
   anker->key    = 0;
   tail->next    = tail;
}

//------------------------------------------------------------------------------
//                   StackEmpty:  Abfragen, ob Stack leer ist
//------------------------------------------------------------------------------

int  StackEmpty (void)
{  return anker->next == tail; }

//------------------------------------------------------------------------------
//                      push:  Item in den Stack bringen
//------------------------------------------------------------------------------
void push (int value)
{
   item = (ITEM *)malloc(sizeof( *item));
   item->key = value;
   item->next = anker->next;
   anker->next = item;
}

//------------------------------------------------------------------------------
//                      pop:  Item vom Stack holen
//------------------------------------------------------------------------------
int pop (void)
{
   int value;
   item = anker->next;
   anker->next = item->next;
   value=item->key;
   free(item);
   return value;
}
